% =======================================================
% Demo routine of RPSA, for solving real pseudospectrum by 
%   criss-cross methods.
%
% Revised: Jun. 13, 2016. 
% =======================================================

% Matrix A (GL matrix), and perturbation level
A = [   .1019 -.8350 .2966 -.0756 -2.2079 1.2682;
        1.1813 -1.4224 -.8664 .8003 -1.3413 1.3547;
       -1.2457 -.1737 -1.1910 -.3194 -.2909 .8230;
       -.7830 -.5115 -.0109 .8860 .4878 .3264;
       -.5740 .0268 1.1950 -.1729 .9966 -.8003;
       -.3815 -.4476 -.9740 1.4030 1.0361 .7399];
epsln = 10^-.25;

% call RPSA
opts.dodisp = true;
[alpha, info] = rpsa(A, epsln, opts)

% display error
z = info.z;
k = info.its;
fprintf('=============== Absolute error =================\n')   
fprintf('%9s  %18s    %7s\n\n', 'k', 'alpha_k', '|alpha_k-alpha|');
fprintf('%9i  %+16.15E    %2.1E\n', ...
    [[0:1:k]', real(z), abs(real(z) - alpha)]');
fprintf('================================================\n')   
