% =======================================================
% Demo routine of RPSAS, for solving real pseudospectrum 
%   by subspace methods.
%
% Revised: Jun. 13, 2016. 
% =======================================================

A = gallery('grcar', 100);  % generate coefficient matrix
epsln = .3;
opts.dodisp = true;
opts.gmod = 'a';
% opts.gmod = 'e';
opts.mode = 'e'; % expand subspace using eigenvectors
opts.mode = 's'; %   or using only singular vectors (STANDARD)
[alpha, info] = rpsas(A, epsln, opts)

% display error
z = info.z;
k = info.its;
fprintf('=============== Absolute error =================\n')   
fprintf('%9s  %18s    %7s\n\n', 'k', 'alpha_k', '|alpha_k-alpha|');
fprintf('%9i  %+16.15E    %2.1E\n', ...
    [[0:1:k]', real(z), abs(real(z) - alpha)]');
fprintf('================================================\n')   
